//#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("sse", "sse2", "sse3", "ssse3", "sse4")

#include <bits/stdc++.h>

#define all(a) a.begin(),a.end()
#define len(a) (int)(a.size())
#define mp make_pair
#define pb push_back
#define fir first
#define sec second
#define fi first
#define se second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<typename T>
bool umin(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
bool umax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

#ifdef KIVI
#define DEBUG for (bool _FLAG = true; _FLAG; _FLAG = false)
#define LOG(...) print(#__VA_ARGS__" ::", __VA_ARGS__) << endl
template <class ...Ts> auto &print(Ts ...ts) { return ((cerr << ts << " "), ...); }
#else
#define DEBUG while (false)
#define LOG(...)
#endif

const int max_n = 1e6 + 11, inf = 1000111222;

namespace fastio {

    const int buf_size = 1 << 14, small = 30;
    char buf_read[buf_size + small];
    char buf_write[buf_size + small];
    char *ptr_read = buf_read + buf_size;
    char *ptr_write = buf_write;

    char getChar() {
        if (ptr_read == buf_read + buf_size){
            buf_read[fread(buf_read, 1, buf_size, stdin)] = 0;
            ptr_read = buf_read;
        }
        return *ptr_read++;
    };

    inline bool is_whitespace(char c) {
        return c == ' ' || c == '\r' || c == '\n';
    }

    char read_char() {
        char c = getChar();
        while (is_whitespace(c)) {
            c = getChar();
        }
        return c;
    }

    string read_string() {
        string res;
        char c = read_char();
        do {
            res += c;
            c = getChar();
        } while (c && !is_whitespace(c));
        return res;
    }

    long long read_int() {
        char c = getChar();
        while (c && (c < '0' || c > '9') && c != '-') {
            c = getChar();
        }
        long long z = 1;
        if (c == '-') {
            z = -1;
            c = getChar();
        }
        long long res = 0;
        while (c >= '0' && c <= '9'){
            res = res * 10 + (c - '0');
            c = getChar();
        }
        return z * res;
    }

    void write_flush() {
        fwrite(buf_write, 1, ptr_write - buf_write, stdout);
        ptr_write = buf_write;
    }

    void write_int(long long x) {
        if (x < 0) {
            *ptr_write++ = '-';
            x = -x;
        }
        char *start = ptr_write;
        if (!x) {
            *ptr_write++ = '0';
        }
        while (x) {
            *ptr_write++ = x % 10 + '0';
            x /= 10;
        }
        reverse(start, ptr_write);
        if (ptr_write >= buf_write + buf_size) {
            write_flush();
        }
    }

    void write_char(char c) {
        *ptr_write++ = c;
        if (ptr_write >= buf_write + buf_size) {
            write_flush();
        }
    }

    void write_string(const string &s) {
        for (char c : s) {
            write_char(c);
        }
    }

}


struct ed {
    int v, to;

    bool operator < (const ed &x) const {
        return v < x.v;
    }

} e[max_n * 2];

int l[max_n];

int mx = -1, ver;

inline void dfs (int v, int p = -1, int dist = 0) {
    if (umax(mx, dist)) {
        ver = v;
    }
    for (int id = l[v]; id < l[v + 1]; id++) {
        int to = e[id].to;
        if (to == p) {
            continue;
        }
        dfs(to, v, dist + 1);
    }
}

int path[max_n], counter;

inline bool go (int v, int b, int p = -1) {
    path[counter++] = v;
    if (v == b) {
        return true;
    }
    for (int id = l[v]; id < l[v + 1]; id++) {
        int to = e[id].to;
        if (to == p) {
            continue;
        }
        if (go(to, b, v)) {
            return true;
        }
    }
    --counter;
    return false;
}

inline int get_path (int a, int b) {
    counter = 0;
    go(a, b);
    return counter;
}

int save;

inline bool check (int v, int p, int need) {
    if (need == 1) {
        save = v;
        return true;
    }
    for (int id = l[v]; id < l[v + 1]; id++) {
        int to = e[id].to;
        if (to == p) {
            continue;
        }
        if (check(to, v, need - 1)) {
            return true;
        }
    }
    return false;
}

int used[max_n], have[max_n], deg[max_n], good[max_n];

ed ss[max_n];


int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

//    ios_base::sync_with_stdio(0);
//    cin.tie(0);


    int n;
    n = fastio::read_int();
//    cin >> n;
    int num1 = 0;
    for (int i = 1, a, b; i < n; i++) {
        a = fastio::read_int();
        b = fastio::read_int();
//        cin >> a >> b;
        --a, --b;

//        e[num1++] = {a, b};
//        e[num1++] = {b, a};
        ++l[a];
        ++l[b];
        ss[i] = {a, b};
    }
    for (int i = 1; i <= n; i++) {
        l[i] += l[i - 1];
        deg[i] = l[i - 1];
    }
    for (int i = n; i > 0; i--) {
        l[i] = l[i - 1];
    }
    l[0] = 0;
    for (int i = 1; i < n; i++) {
        e[deg[ss[i].v]++] = ss[i];
        e[deg[ss[i].to]++] = {ss[i].to, ss[i].v};
    }


    dfs(0);
    mx = -1;
    int a = ver;
    dfs(a);
    int b = ver;
    int sz = get_path(a, b);
    for (int i = 0; i < sz; i++) {
        good[i] = path[i];
    }
    for (int i = 0; i < sz; i++) {
        used[good[i]] = 1;
    }
    int mid1 = sz / 2;
    int mid2 = mid1;
    if (sz % 2 == 0) {
        --mid1;
    }
    vector <int> gg;
    int lft = a, rght = b;
    bool ok = false;
    int really_good = -1, lft_val = sz / 2 + 1, rght_val = sz / 2 + 1;

    for (int i = 0; i < sz; i++) {
        int now = min(i, sz - 1 - i);
        int num = 0;
        for (int id = l[good[i]]; id < l[good[i] + 1]; id++) {
            int to = e[id].to;
            if (used[to]) {
                continue;
            }
            if (check(to, good[i], now)) {
                have[num++] = save;
                if (i + i + 1 == sz) {
                    really_good = to;
                }
                if (num == 2) {
                    break;
                }
            }
        }
        if (i + i + 1 == sz) {
            for (int j = 0; j < num && j < 2; j++) {
                gg.pb(have[j]);
            }
            continue;
        }
        if (i <= mid1) {
            if (num) {
                lft_val = sz / 2 - i + 1;
                lft = have[0];
            }
        }
        if (i >= mid2) {
            if (num) {
                if (!ok) {
                    ok = true;
                    rght_val = i - sz / 2 + 1;
                    rght = have[0];
                }
            }
        }
    }
    auto calc = [&] (int u, int v) {
        int c = get_path(u, v);
        int cur = 0;
        for (int i = 0; i < c; i++) {
            cur += used[path[i]];
        }
        return cur;
    };
    if (!gg.empty()) {
        if (len(gg) > 1) {
            lft = gg[0];
            rght = gg[1];
        }
        else {
            int root = gg[0];
            auto new_path = get_path(really_good, root);
            for (int i = 0; i < new_path; i++) {
                used[path[i]] = 2;
            }
            int down_val = sz / 2 + 1;
            int last = root;
            for (int i = 0; i < new_path; i++) {
                int v = path[i];
//                fastio::write_int(v);
//                fastio::write_char('v');
//                fastio::write_char('\n');
                bool now = false;
                for (int id = l[v]; id < l[v + 1]; id++) {
                    int to = e[id].to;
                    if (used[to]) {
                        continue;
                    }
                    int need = sz / 2 - i - 1;
                    if (check(to, v, need)) {
                        down_val = i + 2;
                        last = v;
                        now = true;
                        break;
                    }
                }
                if (now) {
                    break;
                }
            }
//            fastio::write_int(down_val);
//            fastio::write_char('\n');
//            fastio::write_int(rght_val);
//            fastio::write_char('\n');
//            fastio::write_int(lft_val);
//            fastio::write_char('\n');
//            fastio::write_char('\n');
            if (down_val <= lft_val && down_val <= rght_val) {
                fastio::write_int(sz);
                fastio::write_char('\n');
                auto res2 = get_path(root, a);
                for (int i = 0; i < sz; i++) {
                    fastio::write_int(path[i] + 1);
                    fastio::write_char(' ');
                }
                fastio::write_char('\n');
                auto res3 = get_path(save, b);
                for (int i = 0; i < sz; i++) {
                    fastio::write_int(path[i] + 1);
                    fastio::write_char(' ');
                }
                fastio::write_char('\n');
                fastio::write_flush();
                return 0;
            }
            if (lft_val < rght_val) {
                rght = root;
            }
            else {
                lft = root;
            }
        }
    }
    fastio::write_int(sz);
    fastio::write_char('\n');
//    cout << len(good) << '\n';
    auto res2 = get_path(lft, rght);
    for (int i = 0; i < sz; i++) {
//        cout << i + 1 << ' ';
        fastio::write_int(good[i] + 1);
        fastio::write_char(' ');
    }
    fastio::write_char('\n');
    for (int i = 0; i < sz; i++) {
        fastio::write_int(path[i] + 1);
        fastio::write_char(' ');
    }
    fastio::write_char('\n');
    fastio::write_flush();
}
